***************************************************************************
**  EFFECTS.PRG
**  (C) Copyright 1990-92, Sub Rosa Publishing Inc.
**
**  A demonstration program provided to VP-Info users.
**  This program may be copied freely. If it is used in commercial code,
**  please credit the source, Sub Rosa Publishing Inc.
**
**  EFFECTS is compatible with all current versions (3.30 and over) of
**  VP-Info.
**
**  CAUTION: The Sub Rosa special effects package has been tested on
**  a wide range of systems. There are a few hardware/combinations with
**  which these features confilict.
**
**  VP-Info Level 1 users can control the effects package with the
**  SET SOUND command (default is SOUND ON). For other Info users,
**  a Noeffects command in your .SET file will disable these effects.
**  This program will still run, but quietly and with less flair.
**
**  EFFECTS.PRG moves displays between VPI-Info screens, and produces a range
**  of sounds in the process.
**
**  Bernie Melman and Sid Bursten
***************************************************************************
temp=0
CLS ; clears screen
SET SOUND ON
SCREEN 2 ; write to background screen 2 nothing will show
CLS ; clear this screen as well
BOX 1,1,24,78 ; single line box
:color=iff(:color<>7,116,7)  ; red on grey
COLOR :color,2,2,23,77,3 ; hearts that the reason for red
SCREEN 2,3 ; copy screen 2 to screen 3
** put a smaller box of clubs inside the hearts
SCREEN 3
:color=iff(:color=7,7,112) ; black on grey
BOX 5,5,19,74 double
COLOR :color,6,6,18,73,5 ; clubs
SCREEN 3,4
** put a smaller box of diamonds inside the clubs
SCREEN 4
:color=iff(:color=7,7,116)
BOX 8,9,16,70
COLOR :color,9,10,15,69,4 ; diamonds
SCREEN 1 ; back to home screen
SCREEN t ; use tear effect to put up 1st screen
* produce a variety of sound effects while rotating the display
REPEAT 9 times varying temp
   SOUND temp
   DELAY .5
   SCREEN 2,1
   DELAY .5
   SCREEN 3,1
   DELAY .5
   SCREEN 4,1
ENDREPEAT
* now show off screen effects - all of which move screen 2 to screen 1
DELAY 3
CLS
SCREEN T ; Tear
DELAY 1
CLS
SCREEN R ; Right
DELAY 1
CLS
SCREEN L ; Left
DELAY 1
CLS
SCREEN U
DELAY 1
CLS
SCREEN D
DELAY 1
CLS
DELAY 3
:color=iff(:color=7,7,31)
CLS
? "Now watch some screen swapping with no delays and no special effects."
? "Press any key - except the escape key, please."
DUMMY = inkey()
PERFORM fast
:color=iff(:color=7,7,31)
? "end of demo - one moment please."
DELAY 2
CLS
WAIT
SET sound off
CHAIN samples
*
PROCEDURE fast
   REPEAT 10 times
      SCREEN 2,1
      SCREEN 3,1
      SCREEN 4,1
   ENDREPEAT
ENDPROCEDURE; fast
*
*                         *** end of program EFFECTS.PRG ***
